﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using Infragistics.Windows.DataPresenter;
using Infragistics.Windows.Controls;

namespace DemoDataSources.WpfApp.Helpers
{

	public class XamDataGridHelper : DependencyObject
	{

		public static readonly DependencyProperty FieldsProperty = DependencyProperty.RegisterAttached("Fields", typeof(List<Field>), typeof(XamDataGridHelper), new PropertyMetadata(new PropertyChangedCallback(Fields_Changed)));

		public static List<Field> GetFields(DependencyObject obj)
		{
			return (List<Field>)obj.GetValue(FieldsProperty);
		}

		public static void SetFields(DependencyObject obj, List<Field> value)
		{
			obj.SetValue(FieldsProperty, value);
		}

		private static void Fields_Changed(DependencyObject obj, DependencyPropertyChangedEventArgs e)
		{
			var grid = obj as XamDataGrid;
			var fieldCollection = e.NewValue as List<Field>;

			if (grid == null || fieldCollection == null)
				return;

            //CHANGES-
            string customizations = grid.SaveCustomizations();
            grid.ClearCustomizations(CustomizationType.All);
            //---

			if (grid.FieldLayouts == null || grid.FieldLayouts.Count == 0)
			{
				grid.FieldLayouts.Add(new FieldLayout());
			}
			else
			{
				grid.FieldLayouts[0].Fields.Clear();
			}

			fieldCollection.ForEach(grid.FieldLayouts[0].Fields.Add);

            //CHANGES-
            grid.LoadCustomizations(customizations);
            //---
		}

	}

}
