﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Text;
using DemoDataSources.Models;

namespace DemoDataSources.Repository
{

  public class BorderCrossingRepository
  {

    private string dataFile = @"BorderCrossing2000-2008.csv";
    private List<BorderCrossing> data;

    public BorderCrossingRepository()
    {
      data = GetData();
    }

    public IQueryable<BorderCrossing> Get()
    {
      return data.AsQueryable();
    }

    public BorderCrossing Get(int id)
    {
      return Get().FirstOrDefault(i => i.Id == id);
    }

    private List<BorderCrossing> GetData()
    {

      var table = Helpers.CsvReader.ReadCsvFile(dataFile, true);
      var items = ConvertDataTableToList(table);
      return items;
    }

    private List<BorderCrossing> ConvertDataTableToList(DataTable table)
    {
      var items = new List<BorderCrossing>();
      int i = 0;
      int idx;
      foreach (var row in table.Rows.Cast<DataRow>())
      {
        idx = 0;

        var item = new BorderCrossing
        {

          Id = i++,
          State = row[idx].ToString().Split(':')[0],
          Port = row[idx++].ToString().Split(':')[1],
          Year = ReadInt(row[idx++].ToString()),
          Month = row[idx++].ToString(),
          Trucks = ReadInt(row[idx++].ToString()),
          LoadedTrucks = ReadInt(row[idx++].ToString()),
          EmptyTrucks = ReadInt(row[idx++].ToString()),
          Trains = ReadInt(row[idx++].ToString()),
          LoadedRailContainers = ReadInt(row[idx++].ToString()),
          EmptyRailContainers = ReadInt(row[idx++].ToString()),
          TrainPassengers = ReadInt(row[idx++].ToString()),
          Buses = ReadInt(row[idx++].ToString()),
          BusPassengers = ReadInt(row[idx++].ToString()),
          PersonalVehicles = ReadInt(row[idx++].ToString()),
          PassengersPersonalVehicles = ReadInt(row[idx++].ToString()),
          Pedestrians = ReadInt(row[idx++].ToString()),

        };
        items.Add(item);

      }

      return items;
    }

    public int ReadInt(string str)
    {
      int value = 0;
      if (int.TryParse(str, out value))
        return value;
      return value;
    }
  }

}
